package cz.jzitnik.chronos.services;

import cz.jzitnik.chronos.entities.*;
import cz.jzitnik.chronos.entities.Character;
import cz.jzitnik.chronos.interactions.Interaction;
import org.springframework.stereotype.Service;

import java.util.ArrayList;

@Service
public class InitGameService {
    public Room initGame(Game game) {
        var rooms = new ArrayList<Room>();

        // Outside
        var outside = new Room(
                "Outside", // Name
                game
        );
        var outside_characters = new ArrayList<Character>();
        var elf_items = new ArrayList<Item>();
        var elf = new Character(
                "Skřítek",
                outside,
                "Ahoj já jsem skřítek... Můj dialog doplnit"
        );
        elf_items.add(new Item(ItemType.LUCK_POTION, elf));
        elf.setInventory(elf_items);
        outside_characters.add(elf);
        outside.setCharacters(outside_characters);

        // Stodola
        var stodola = new Room(
                "Stodola",
                game
        );
        var stodola_characters = new ArrayList<Character>();
        var farmar = new Character(
                "Farmář",
                stodola,
                "Ahoj já jsem farmář a budeš se mnou hrát kámen nůžky papír. Dialog doplnit."
        );
        farmar.setInteraction(Interaction.Farmer);
        farmar.setInteractionData(new cz.jzitnik.chronos.entities.Interaction(
                "Tak si zahrajeme kámen nůžky papír",
                "Se mnou někdo již hrál kámen nůžky papír. Další fragment klíče nemám.",
                farmar
        ));
        stodola_characters.add(farmar);
        stodola.setCharacters(stodola_characters);

        // Shop
        var shop = new Room(
                "Obchod",
                game
        );
        var shop_characters = new ArrayList<Character>();
        var cashier = new Character(
                "Prodavač",
                shop,
                "Ahoj já jsem prodavač a budeš se mnou hrát šibenici."
        );
        cashier.setInteraction(Interaction.Cashier);
        cashier.setInteractionData(new cz.jzitnik.chronos.entities.Interaction(
                "Tak si zahrajeme šibenici",
                "Se mnou někdo již hrál šibenici. Další fragment klíče nemám.",
                cashier
        ));
        shop_characters.add(cashier);
        shop.setCharacters(shop_characters);

        // Knihovna
        var library = new Room(
                "Knihovna",
                game
        );
        var library_characters = new ArrayList<Character>();
        var librarian = new Character(
                "Knihovník",
                library,
                "Ahoj já jsem knihovník a budeš se mnou hrát wordle."
        );
        librarian.setInteraction(Interaction.Librarian);
        librarian.setInteractionData(new cz.jzitnik.chronos.entities.Interaction(
                "Tak si zahrajeme wordle.",
                "Se mnou někdo již hrál wordle. Další fragment klíče nemám.",
                librarian
        ));
        library_characters.add(librarian);
        library.setCharacters(library_characters);


        rooms.add(outside);
        rooms.add(stodola);
        rooms.add(shop);
        rooms.add(library);

        game.setRooms(rooms);

        // Return a room that all players will spawn in
        return outside;
    }
}